import re
import sha

kenosisDomainString = "(0x)?(\w+).(node\.)?(\w+)\.kenosisp2p\.org"
kenosisDomainRe = re.compile(kenosisDomainString)
kenosisUrlRe = re.compile("\w+://" + kenosisDomainString)

def domainName(service):
    return "%s.kenosisp2p.org" % service

def stringAddressFrom(service, url=None, domain=None):
    assert url or domain
    assert not (url and domain)

    if domain:
        m = kenosisDomainRe.match(domain)
    else:
        m = kenosisUrlRe.match(url)
    if m and m.group(4) == service:
        data = m.group(2)
        isnode = bool(m.group(3))
        #=== add "0x" here?
        if isnode:
            return "0x" + data
        else:
            return "0x" + sha.sha(data).hexdigest()
    else:
        return None


