import os, sys
sys.path.append(os.path.join(os.getcwd(), sys.path[0], ".."))
from ds import dsunittest
dsunittest.setTestName("dns/__init__.py")

from kenosis import address
from kenosis import dns
from ds import dstime

import socket

class Test(dsunittest.TestCase):
    def setUp(self):
        dstime.setTestingTime(0)
        socket.setdefaulttimeout(0.5)

    def tearDown(self):
        pass

    def testSimple(self):
        na = dns.nodeAddressFrom(service="bt",
                                 url="http://FFFAAFFF.node.bt.kenosisp2p.org:1234/asdfasdf/asdf/d/")
        self.assertEqual(na, address.stringToAddress("0xFFFAAFFF"))
        na = dns.nodeAddressFrom(service="bt",
                                 domain="FFFAAFFF.node.bt.kenosisp2p.org")
        self.assertEqual(na, address.stringToAddress("0xFFFAAFFF"))
        na = dns.nodeAddressFrom(service="bt",
                                 domain="adfasdf")
        self.assertEqual(na, None)

        na = dns.nodeAddressFrom(service="bt",
                                 domain="foo.bt.kenosisp2p.org")
        import sha
        ob = sha.sha()
        ob.update("foo")
        addr = "0x%s" % ob.hexdigest()
        self.assertEqual(na, address.stringToAddress(addr))
        
        

if __name__ == "__main__":
    dsunittest.main()
