import os, sys
sys.path.append(os.path.join(os.getcwd(), sys.path[0], ".."))

import cmd
import re
import sys

import kenosis

class KimHandler:
    def onMessage(self, message):
        print("new message: %s" % message)
        return 0

class KimCmd(cmd.Cmd):
    def __init__(self):
        cmd.Cmd.__init__(self)

        configPath = sys.argv[1]
        self.node_ = kenosis.Node(ports=range(6885, 6889), configPath=configPath)
        self.node_.registerNamedHandler(name="kim", handler=KimHandler())
        self.node_.save()
        print("node address is: %s" % self.node_.stringAddress())
        self.buddies_ = {}

        self.cmdloop()

    def do_addBuddy(self, line):
        buddyStringAddress = line
        self.buddies_[buddyStringAddress] = buddyStringAddress

    def do_m(self, line):
        m = re.match("([^ ]+) (.*)", line)
        if not m:
            print("syntax is: m buddy-address message")
            return
        buddyStringAddress = m.group(1)
        message = m.group(2)
        try:
            self.node_.rpc(stringAddress=buddyStringAddress).kim.onMessage(message)
        except kenosis.NodeNotFound:
            print("error sending message (node not found)")

def main():
    kimCmd = KimCmd()

if __name__ == "__main__":
    main()
